package com.example.mobapp_o_useservice1;

import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBar;
import android.support.v4.app.Fragment;
import android.support.v4.content.LocalBroadcastManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.os.Build;

public class MainActivity extends ActionBarActivity {
	
	private class ResponseReceiver extends BroadcastReceiver
	{
		@Override
		public void onReceive(Context arg0, Intent arg1) {
			int status = arg1.getIntExtra(Service4.EXTENDED_DATA_STATUS,0);
			NotificationHelper.showNotification(MainActivity.this, "Broadcast", "Status "+status);
			ProgressBar bar = (ProgressBar)findViewById(R.id.progressBar1);
			bar.setProgress(status);
		}
	}
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		IntentFilter filter = new IntentFilter(Service4.BROADCAST_ACTION);
		ResponseReceiver receiver = new ResponseReceiver();
        LocalBroadcastManager.getInstance(this).registerReceiver(
        		receiver, filter);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	Intent intent2 = null;
	
	public void startService1(View v) {
		Intent intent1 = new Intent(this, Service1.class);
		startService(intent1);
	}

	public void startService2(View v) {
		if (intent2==null)
			intent2 = new Intent(this, Service2.class);
		startService(intent2);
	}
	
	public void stopService2(View v) {
		if (intent2!=null) {
			stopService(intent2);
			intent2 = null;
		}
	}

	public void startService3(View v) {
		Intent intent3 = new Intent(this, Service3.class);
		startService(intent3);
	}
        
	public void startService4(View v) {
		Intent intent4 = new Intent(this, Service4.class);
		startService(intent4);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}


}
